/*
 * Copyright (C) 2012-2013 The Dojo Foundation
 * 
 * Copyright (C) 2012-2013 Rex Young
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package com.fastmessenger.impl;

import java.lang.reflect.Method;
import java.util.HashMap;

class DispatcherManager {

    private HashMap<String, Dispatcher> dispatcherMap = new HashMap<String, Dispatcher> ();

    void addDispatcher (String receiver, Dispatcher dispatcher) {

        dispatcherMap.put (receiver, dispatcher);
    }

    void removeDispatcher (String receiver) {

        dispatcherMap.remove (receiver).stop ();
    }

    Method findPortImplMethodIfAny (Address portAddress, Object... args) {

        Dispatcher dispatcher = dispatcherMap.get (portAddress.getActiveobject ());

        return dispatcher.findServiceMethodIfAny (portAddress.getPort (), args);
    }

    void dispatchPortRequest (PortRequest request) {

        Dispatcher dispatcher = dispatcherMap.get (request.getPortAddress ().getActiveobject ());

        dispatcher.dispatch (request);
    }

}
