/*
 * Copyright (C) 2012-2013 The Dojo Foundation
 * 
 * Copyright (C) 2012-2013 Rex Young
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package com.fastmessenger.impl;

import java.lang.reflect.Method;

class PortRequest {

    static private final Object[] EmptyArgs = new Object[0];

    private int returnValueIndex;
    private Address returnAddress, portAddress;
    private Object[] returnArgs, portArgs;
    private Method portImplMethod;

    PortRequest (Address returnAddress, Object[] returnArgs, int returnValueIndex, Address portAddress,
            Method portImplMethod, Object[] portArgs) {

        setReturnAddress (returnAddress);
        setReturnArguments (returnArgs);
        setReturnValueIndex (returnValueIndex);
        setPortAddress (portAddress);
        setPortImplMethod (portImplMethod);
        setPortArguments (portArgs);
    }

    int getReturnValueIndex () {
        return returnValueIndex;
    }

    void setReturnValueIndex (int returnValueIndex) {
        this.returnValueIndex = returnValueIndex;
    }

    Address getReturnAddress () {
        return returnAddress;
    }

    void setReturnAddress (Address returnAddress) {
        this.returnAddress = returnAddress;
    }

    Address getPortAddress () {
        return portAddress;
    }

    void setPortAddress (Address portAddress) {
        this.portAddress = portAddress;
    }

    Object[] getReturnArguments () {
        return returnArgs;
    }

    void setReturnArguments (Object[] returnArgs) {
        this.returnArgs = returnArgs == null ? EmptyArgs : returnArgs;
    }

    Object[] getPortArguments () {
        return portArgs;
    }

    void setPortArguments (Object[] portArgs) {
        this.portArgs = portArgs == null ? EmptyArgs : portArgs;
    }

    Method getPortImplMethod () {
        return portImplMethod;
    }

    void setPortImplMethod (Method portImplMethod) {
        this.portImplMethod = portImplMethod;
    }

}
