/*
 * Copyright (C) 2012-2013 The Dojo Foundation
 * 
 * Copyright (C) 2012-2013 Rex Young
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package com.fastmessenger.impl;

import java.util.Arrays;
import java.util.HashMap;

class ReceiverManager {

    private HashMap<String, String[]> sortedPortsMap = new HashMap<String, String[]> ();

    void addReceiver (String receiver, String... ports) {

        Arrays.sort (ports);
        sortedPortsMap.put (receiver, ports);
    }

    void removeReceiver (String receiver) {

        sortedPortsMap.remove (receiver);
    }

    String[] getSortedPorts (String receiver) {

        return sortedPortsMap.get (receiver);
    }

}
